package wdbpress.divetojava.examples.fizzbuzz;

import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


@RestController
public class FizzBuzzAPI{

  public static class FizzBuzzCounter{

    private final int fizz;

    private final int buzz;

    private final int fizzbuzz;

    public FizzBuzzCounter(int fizz, int buzz, int fizzbuzz){
      this.fizz = fizz;
      this.buzz = buzz;
      this.fizzbuzz = fizzbuzz;
    }

    public int getFizz(){
      return fizz;
    }

    public int getBuzz(){
      return buzz;
    }

    public int getFizzBuzz(){
      return fizzbuzz;
    }

  }

  @RequestMapping("/fizzbuzz/{val}")
  public FizzBuzzCounter calc(@PathVariable("val") int val){

    if(val < 1){
      throw new IllegalArgumentException("value must be greater than 0");
    }

    int fizz = 0;
    int buzz = 0;
    int fizzbuzz = 0;

    for(int i = 1; i <= val; i++){
      if((i % 15) == 0){
        fizzbuzz++;
      }
      else if((i % 5) == 0){
        buzz++;
      }
      else if((i % 3) == 0){
        fizz++;
      }
    }

    return new FizzBuzzCounter(fizz, buzz, fizzbuzz);
  }

}
